"use strict";
var angular2_universal_1 = require('angular2-universal');
var through = require('through2');
var gutil = require('gutil');
var PluginError = gutil.PluginError;
function prerender(options) {
    function transform(file, enc, cb) {
        if (file.isStream()) {
            return cb(new PluginError('angular2-gulp-prerender', 'Streaming is not supported'));
        }
        var template = file.contents.toString();
        // bootstrap and render component to string
        var _options = options;
        var _template = template;
        var _Bootloader = angular2_universal_1.Bootloader;
        var bootloader = _options.bootloader;
        if (_options.bootloader) {
            bootloader = _Bootloader.create(_options.bootloader);
        }
        else {
            var doc = _Bootloader.parseDocument(_template);
            _options.document = doc;
            _options.template = _options.template || _template;
            bootloader = _Bootloader.create(_options);
        }
        return bootloader.serializeApplication()
            .then(function (html) {
            file.contents = new Buffer(html);
            cb(null, file);
        });
    }
    return through.obj(transform);
}
exports.prerender = prerender;
function GulpAngular2Render(options) {
    console.warn('DEPRECATION WARNING: `GulpAngular2Render` is no longer supported and will be removed in next release. use `prerender`');
    return prerender(options);
}
exports.GulpAngular2Render = GulpAngular2Render;
function Prerender(options) {
    console.warn('DEPRECATION WARNING: `Prerender` is no longer supported and will be removed in next release. use `prerender`');
    return prerender(options);
}
exports.Prerender = Prerender;
//# sourceMappingURL=prerender.js.map